
package net.mcreator.galaxymod.fluid;

import net.neoforged.neoforge.fluids.BaseFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.core.particles.ParticleOptions;

import net.mcreator.galaxymod.init.GalaxyModModItems;
import net.mcreator.galaxymod.init.GalaxyModModFluids;
import net.mcreator.galaxymod.init.GalaxyModModFluidTypes;
import net.mcreator.galaxymod.init.GalaxyModModBlocks;

public abstract class GalaxyfluidFluid extends BaseFlowingFluid {
	public static final BaseFlowingFluid.Properties PROPERTIES = new BaseFlowingFluid.Properties(() -> GalaxyModModFluidTypes.GALAXYFLUID_TYPE.get(), () -> GalaxyModModFluids.GALAXYFLUID.get(), () -> GalaxyModModFluids.FLOWING_GALAXYFLUID.get())
			.explosionResistance(100f).tickRate(1).slopeFindDistance(10).bucket(() -> GalaxyModModItems.GALAXYFLUID_BUCKET.get()).block(() -> (LiquidBlock) GalaxyModModBlocks.GALAXYFLUID.get());

	private GalaxyfluidFluid() {
		super(PROPERTIES);
	}

	@Override
	public ParticleOptions getDripParticle() {
		return ParticleTypes.EXPLOSION;
	}

	public static class Source extends GalaxyfluidFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends GalaxyfluidFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
